%define realversion 2004g
%define soversion 0

Summary: c-client C API for the IMAP protocol
Name: libc-client
Version: 0.0.2004.g
Release: 3tr
License: University of Washington's Free-Fork License
Group: Trustix Official
Source: ftp://ftp.cac.washington.edu/imap/imap-%{realversion}.tar.Z
Patch0: imap-2004c1-trustix.patch
Patch1: imap-2002e-ssl.patch
Patch2: imap-2001a-overflow.patch
Patch3: imap-2002e-yn.patch
Patch4: libc-client-2004c1-version.patch
Buildroot: /var/tmp/%{name}-root
Obsoletes: libimap

%description
Runtime file for programs using the IMAP c-client library

%package devel
Summary: c-client C API for the IMAP protocol development files
Group: Trustix Official
Requires: %{name}

%description devel
Development for programs which will use the IMAP c-client library


%prep

%setup -q -n imap-%{realversion}
%patch0 -p1
#%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS -fPIC" lnp SPECIALAUTHENTICATORS=ssl \
     SSLTYPE=unix.nopwd SSLDIR=/etc/ssl SSLINCLUDE=/usr/include \
     SSLLIB=/usr/lib EXTRACFLAGS="-DDISABLE_POP_PROXT=1" \
     EXTRADRIVERS="" EXTRAAUTHENTICATORS=gss
## create a shared library
LDFLAGS="-lcrypto -lpam -lgnutls -lgssapi_krb5 -lkrb5 -lssl"
gcc -shared -Wl,-soname,libimap.so c-client/*.o -o libc-client.so.%{soversion} $LDFLAGS

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

## Install the shared lib
mkdir -p $RPM_BUILD_ROOT/usr/lib
install -m 755 libc-client.so.%{soversion} $RPM_BUILD_ROOT/usr/lib
install -m 644 ./c-client/c-client.a $RPM_BUILD_ROOT/usr/lib

# Add symlinks as needed.
pushd $RPM_BUILD_ROOT/usr/lib
  ln -sf libc-client.so.%{soversion} libc-client.so
  ln -s c-client.a libc-client.a
popd

mkdir -p $RPM_BUILD_ROOT/usr/include/imap
install -m 644 ./c-client/*.h $RPM_BUILD_ROOT/usr/include/imap
install -m 644 ./src/osdep/tops-20/shortsym.h $RPM_BUILD_ROOT/usr/include/imap

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,0755)
%doc CPYRIGHT docs/RELNOTES docs/*.txt
/usr/lib/*.so.*

%files devel
%defattr(-,root,root,0755)
%doc CPYRIGHT docs/*
/usr/include/imap
/usr/lib/*.a
/usr/lib/*.so

%post
/sbin/ldconfig

%changelog
* Mon Feb 26 2007 Nived Gopalan <nived at trustix dot org>
- Rebuilt

* Thu Feb 15 2007 Bipin S <bipin at trusitx dot org> 0.0.2004.g-2tr
- Obsoletes libimap.

* Wed Dec 21 2005 Nived Gopalan <nived at trustix dot org> 0.0.2004.g-1tr
- New Upstream. 
- SECURITY Fix: infamous41md has reported a vulnerability caused due to a 
  boundary error in the "mail_valid_net_parse_work()" function when copying
  the user supplied mailbox name to a stack buffer. This can be exploited to
  cause a stack-based buffer overflow via a specially crafted mailbox name 
  that contains an single opening double-quote character, without the 
  corresponding closing double-quote.

  The Common Vulnerabilities and Exposures project has assigned the
  name CAN-2005-2933 to this issue.

* Fri Apr 29 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 2004.c.1-2tr
- Built .so with proper LDFLAGS to resolve undefined symbols

* Tue Mar  1 2005 Erlend Midttun <erlendbm at trustix dot org> 2004.c.1-1tr
- New package.  Taken from uw-imap spec-file.

